package cz.muni.fi.lasaris.sbms;

import org.glassfish.grizzly.http.server.HttpServer;
import org.glassfish.grizzly.http.server.StaticHttpHandler;
import org.glassfish.grizzly.ssl.SSLContextConfigurator;
import org.glassfish.grizzly.ssl.SSLEngineConfigurator;
import org.glassfish.jersey.grizzly2.httpserver.GrizzlyHttpServerFactory;

import cz.muni.fi.lasaris.sbms.SBMSApplication;

import java.io.IOException;
import java.net.URI;

/**
 * Main class.
 *
 */
public class Main {
    // Base URI the Grizzly HTTP server will listen on
    //public static final String BASE_URI = "http://datel.ubm.muni.cz:8080/sbms/v1/";

    /**
     * Starts Grizzly HTTP server exposing JAX-RS resources defined in this application.
     * @return Grizzly HTTP server.
     */
    
    private static SBMSApplication app;
    
    public static HttpServer startServer() {
        // create a resource config that scans for JAX-RS resources and providers
        // in com.example package
		app = SBMSApplication.getInstance();
		//new ResourceConfig().packages("cz.muni.fi.lasaris.sbms.api");
        
		
		// https://www.sslshopper.com/article-how-to-create-a-self-signed-certificate-using-java-keytool.html
		// http://stackoverflow.com/questions/21098105/ssl-with-grizzly-and-jersey
		SSLContextConfigurator sslCon = new SSLContextConfigurator();
	    sslCon.setKeyStoreFile("D:/akucera/Semantic BMS/keystore.jks"); // contains server keypair
	    sslCon.setKeyStoreType("JKS");
	    sslCon.setKeyStorePass("password");
		sslCon.setKeyPass("BmS.257");
	    
	    System.out.println(sslCon.validateConfiguration(true));
        // create and start a new instance of grizzly http server
        // exposing the Jersey application at BASE_URI
        
	    HttpServer g = GrizzlyHttpServerFactory.createHttpServer(URI.create(app.getURI()), app, true, 
        		new SSLEngineConfigurator(sslCon, false, false, false));
        
	    //HttpServer g = GrizzlyHttpServerFactory.createHttpServer(URI.create(app.getURI()), app);
        StaticHttpHandler staticHttpHandler = new StaticHttpHandler("D:/akucera/Semantic BMS/html");
        staticHttpHandler.setFileCacheEnabled(false);
        g.getServerConfiguration().addHttpHandler(staticHttpHandler, "/client");
        return g;
    }

    /**
     * Main method.
     * @param args
     * @throws IOException
     */
    public static void main(String[] args) throws IOException {
        final HttpServer server = startServer();
        System.out.println(String.format("Jersey app started with WADL available at "
                + "%sapplication.wadl\nHit enter to stop it...", app.getURI()));
        System.in.read();
        app.close();
        server.shutdownNow();
    }
}

